
require "./AI/USER_AI/Const.lua"
require "./AI/USER_AI/Util.lua"

-----------------------------
-- state
-----------------------------
IDLE_ST						= 0
FOLLOW_ST					= 1
CHASE_ST					= 2
ATTACK_ST					= 3
MOVE_CMD_ST					= 4
STOP_CMD_ST					= 5
ATTACK_OBJECT_CMD_ST		= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8
HOLD_CMD_ST					= 9
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST			= 11
FOLLOW_CMD_ST				= 12
----------------------------


------------------------------------------
-- global variable
------------------------------------------
MyState				= IDLE_ST		-- ŏ̏Ԃ͋x
MyEnemy				= 0				-- G id
MyDestX				= 0				-- ړIn xW
MyDestY				= 0				-- ړIn yW
MyPatrolX			= 0				-- @ړIn xW
MyPatrolY			= 0				-- @ړIn yW
ResCmdList			= List.new()	-- \R}hXg
MyID				= 0				-- zNX id
MySkill				= 0				-- zNX̃XL
MySkillLevel		= 0				-- zNX̃XLx
------------------------------------------
MyOWNER				= GetV(V_OWNER,MyID)	-- l̃AP~XgID擾
MyMASTER			= MyOWNER				-- ݂̃}X^[

------------------------------------------

------------------------------------------
-- tB[XLݒ
------------------------------------------
-- 萔
IN_SKILL_MOONLIGHT		= 8009		-- [Cg
MOONLIGHT_LV			= 5			-- [Cggpx(0ɂƔȂ)
MOONLIGHT_R_CANCELER	= 0			-- 蓮gp̎˒(0FOFF 1FON)
AUTO_SKILL				= 1			-- [CgŒᎩ()({cSPɂϓ)
AUTO_SKILL_SP			= 2			-- cSPʂɂ郀[Cgǉ(cSP100̎̒ǉ)
MOONLIGHT_SPLIMIT		= 50		-- zSṔꍇɂ̓[CgȂ
	--------------------------------------
	-- ~bguCN[h
	-- orl(ꎞ}X^[͏)HPlȉ̏ꍇ
	-- [Cg̔グ܂B
	-- ȀԂł MOONLIGHT_SPLIMIT 𖳎܂
	--------------------------------------
LIMIT_BREAK				= 50		-- ~bguCN[h̃[Cg㏸l()
BREAK_POINT				= 20		-- zHṔꍇA~bguCN
BREAK_POINT_OWNER		= 30		-- lHṔꍇA~bguCN


IN_SKILL_FLEETMOVE		= 8010		-- tbg[u
FLEETMOVE_LV			= 0			-- tbg[ugpx(0ɂƎgpȂ)
FLEETMOVE_SPLIMIT		= 20		-- zSṔꍇɂ̓tbg[uȂ


IN_SKILL_OVEREDSPEED	= 8011		-- I[o[hXs[h
OVERDSPEED_LV			= 0			-- I[o[hXs[hgpx(0ɂƎgpȂ)
OVERDSPEED_SPLIMIT		= 10		-- zSṔꍇɂ̓I[o[hXs[hȂ

SKILL_INTERVAL			= 1000		-- XLgpԊu(~b)

-- ϐ
FleetMove_Interval		= 0			-- tbg[ugpԊu
OverdSpeed_Interval		= 0			-- I[o[hXs[hgpԊu
Skill_Delay				= 0			-- XLfBCvZp


------------------------------------------
-- ǔp
------------------------------------------
-- 萔
FOLLOW_INTERVAL			= 500		-- ǔT[`Ԋu(~b)
-- ϐ
Follow_Time				= 0			-- ǔԂ̐ݒ(l0̂܂܂ok)


------------------------------------------
-- ҋ@s
------------------------------------------
-- 萔
IDLE_DELAY				= 10		-- ҋ@sJn܂ł̎(b)
IDLE_FLAG				= 6			-- sJn
PATROL_MIN				= 8			-- ]ŏ(41])
PATROL_MAX				= 12		-- ]ő(41])
PATROL_SPEED			= 250		-- ]x(~b)
PATROL_RANGE			= 1			-- ]a
PATROL_REST				= 80		-- z̎cSṔȉ̏ꍇ͐Î~i񕜂̂߁j

-- ϐ
First_Idle_Flag			= 0			-- ACḧړtO
Idle_Time				= 0			-- ҋ@sԂ̐ݒ
Idle_Count				= 0			-- sJn񐔂̐ݒ

PatrolVector			= 0			-- ݉]
PatrolDirection			= 0			-- ]̗ݒ
PatrolCount				= 0			-- ]񐔂̂߂̐ݒ
PatrolFlag				= 0			-- ]񐔂̗ݒ
WaitClock				= 0			-- ]x̂߂̐ݒ

------------------------------------------
-- XebvR}h
------------------------------------------
-- 萔
COMMAND_LIMIT			= 4000		-- ͐(~b)
-- ϐ
Attack_Mode				= 0			-- sݒ菉l(0FmANeBu 1FANeBu)
Command_Type			= 0			-- R}h
Command_Count			= 0			-- R}h̓JE^
Command_Conplete		= false		-- R}htO
Command_Time			= 0			-- ͐

Master_Change_X			= 0			-- }X^[ꎞւR}h̊XW
Master_Change_Y			= 0			-- }X^[ꎞւR}h̊YW

Follow_Target			= 1			-- }X^[ꎞւ̒ǔΏ(0FI[i[ 1Fꎞ}X^[)

------------------------------------------
-- ̑
------------------------------------------
EXIT_TIME				= 1800		-- Q΍􎞊(b)


----------- original process  ------------



------------------------------------------
-- zNX̎푰 (tB[)
------------------------------------------
function IsFILIR ()
	local type = GetV(V_HOMUNTYPE, MyID)
	
	if (type == FILIR or type == FIRIR2 or type == FILIR_H or type == FILIR_H2) then
		return true
	end
	
	return false
	
end

------------------------------------------
-- Ώۂ̃vC[f (True:vC[ False:̑)
------------------------------------------
function IsPlayer (id)
	if (IsMonster(id) == 1) then
		return false
	elseif (id < 65536 or id == -1) then		-- id < 65536 ̏ꍇAl̃z͏
		return false
	end
	local type = GetV(V_HOMUNTYPE,id)

	if (0 <= type and type <= 23) then
		return true
	elseif (4001 <= type and type <= 4044) then
		return true
	elseif (4046 <= type and type <= 4050) then
		return true
	else
		return false
	end
end

------------------------------------------
-- ARMOB`FbN
------------------------------------------
function IsPlant(target)
-- [1078]Ԃ
-- [1079]
-- [1080]ΐF
-- [1081]F
-- [1082]
-- [1083]P
-- [1084]̂
-- [1085]Ԃ̂

-- [1008]vp
-- [1047]yRyR̗
-- [1048]X峂̗
-- [1097]a̗
-- [1142]}XtBA

-- [1589]}hS(oCIvg)
-- [1579]qh(oCIvg)
-- [1575]t[(oCIvg)
-- [1555]tFA[t(oCIvg)
-- [1590]WIOt@[(oCIvg)
	if(target >= 1078 and target <= 1085) then															-- ^[Qbgor̂̏ꍇ
		return true
	elseif(target == 1008 or target == 1047 or target == 1047 or target == 1097 or target == 1142) then	-- ^[QbgRMOB̏ꍇ
		return true
	elseif(targer == 1589 or target == 1575 or target == 1579 or target == 1555 or target == 1590) then	-- ^[QbgoCIvg̏ꍇ
		return true
	end
	
	return false
end

------------------------------------------
-- ړ^MOB`FbN
------------------------------------------
function IsNoMove(target)
-- [1020]}hS
-- [1068]qh
-- [1118]t[
-- [1277]V叫R
-- [1368]WIOt@[

	if(target == 1020 or target == 1068 or target == 1118 or target == 1277 or target == 1368) then		-- ^[Qbgړ^̏ꍇ
		return true
	end

	return false
end


------------------------------------------
-- XL̎gp([Cg)
------------------------------------------
function Auto_Skill_MoonLight ()

		if IsFILIR() then		-- tB[
			MySkill = IN_SKILL_MOONLIGHT	-- [Cg
			MySkillLevel = MOONLIGHT_LV		-- gpx
		else
			MySkill = 0	
			MySkillLevel = 0
		end
		
		if (MySkill == 0 and MySkillLevel == 0) then		-- XLZbgĂȂꍇ
			return false	-- ʏU
		end
		
		if (GetV(V_MOTION, MyOWNER) == MOTION_SIT) then		-- lĂꍇ
			return false	-- ʏU
		end
		
		if (Skill_Delay > GetTick()) then					-- XLfBC̏ꍇ
			return false	-- ʏU
		end

		if IsPlant(GetV(V_HOMUNTYPE,MyEnemy)) then			-- ARMOB̏ꍇ
			return false	-- ʏU
		end

		-- zSPԂ擾
		local HomunculusSP = GetV (V_SP,MyID)
		local HomunculusMaxSP = GetV (V_MAXSP,MyID)
		
		if (HomunculusSP < MySkillLevel * 4) then				-- SPȂꍇ
			return false	-- ʏU
		end
		
		-- lHPԂ擾
		local OwnerHP = GetV (V_HP,MyOWNER)
		local OwnerMaxHP = GetV (V_MAXHP,MyOWNER)
		-- zHPԂ擾
		local HomunculusHP = GetV (V_HP,MyID)
		local HomunculusMaxHP = GetV (V_MAXHP,MyID)
		
		local AutoSkillProbability = AUTO_SKILL
		
		if ((HomunculusHP/HomunculusMaxHP)*100 < BREAK_POINT or (OwnerHP/OwnerMaxHP)*100 < BREAK_POINT_OWNER) then
			-- ~bguCN[h
			AutoSkillProbability = AutoSkillProbability + LIMIT_BREAK	-- ̒グ
			TraceAI ("AUTO_SKILL_MOONLIGHT : LIMIT BREAK")
		elseif (MOONLIGHT_SPLIMIT > (HomunculusSP/HomunculusMaxSP)*100) then	-- SPlȉ̏ꍇ
			return false	-- ʏU
		end

		-- cSPɂĔm𒲐
		AutoSkillProbability = AutoSkillProbability + ((HomunculusSP/HomunculusMaxSP) * AUTO_SKILL_SP)

		-- ΂𓊂
		local Dice = math.floor(math.random(100))
		if (AutoSkillProbability > Dice) then
			return true		-- XLU
		else
			return false	-- ʏU
		end

end
------------------------------------------
-- XL̎gp(tbg[u)
------------------------------------------
function Auto_Skill_FleetMove ()

	local casting = false
	
	if (Skill_Delay > GetTick()) then					-- XLfBC͎gpłȂ
		return
	end

	if (GetV(V_MOTION, MyOWNER) == MOTION_SIT) then		-- lĂ鎞͎gpłȂ
		return
	end
	
	if (FLEETMOVE_LV ~= 0) then					-- x0ŵƂ͎gpȂ
		if (FleetMove_Interval == 0 or FleetMove_Interval <= GetTick()) then
			local HomunculusSP = GetV (V_SP,MyID)				-- ݂SP
			local HomunculusMaxSP = GetV (V_MAXSP,MyID)			-- MaxSP
			-- SPlȉ̏ꍇ͔Ȃ
			if (FLEETMOVE_SPLIMIT < (HomunculusSP / HomunculusMaxSP)*100 and HomunculusSP ~= 0) then
				if (GetV(V_SP, MyID) > FLEETMOVE_LV * 10 + 20) then		-- SPȂꍇ͔Ȃ
					casting = true
				end
			end
		end
	end

	if (casting == true) then
		FleetMove_Interval = GetTick() + 65000 - FLEETMOVE_LV * 5000	-- ɂ܂ł̎
		-- tbg[ugp
		SkillObject(MyID, FLEETMOVE_LV, IN_SKILL_FLEETMOVE, MyID)
		Skill_Delay =  GetTick() + SKILL_INTERVAL					-- ɃXLgpł鎞
		MyDestX = 0
		MyDestY = 0
		TraceAI ("AUTO_SKILL_FLEETMOVE")
	end
end

------------------------------------------
-- XL̎gp(I[o[hXs[h)
------------------------------------------
function Auto_Skill_OverdSpeed ()

	local casting = false
	
	if (Skill_Delay > GetTick()) then					-- XLfBC͎gpłȂ
		return
	end
	
	if (GetV(V_MOTION, MyOWNER) == MOTION_SIT) then		-- lĂ鎞͎gpłȂ
		return
	end
	
	if (OVERDSPEED_LV ~= 0) then					-- x0ŵƂ͎gpȂ
		if (OverdSpeed_Interval == 0 or OverdSpeed_Interval <= GetTick()) then
			local HomunculusSP = GetV (V_SP,MyID)				-- ݂SP
			local HomunculusMaxSP = GetV (V_MAXSP,MyID)			-- MaxSP
			-- SPlȉ̏ꍇ͔Ȃ
			if (OVERDSPEED_SPLIMIT < (HomunculusSP / HomunculusMaxSP)*100 and HomunculusSP ~= 0) then
				if (GetV(V_SP, MyID) > OVERDSPEED_LV * 10 + 20) then	-- SPȂꍇ͔Ȃ
					casting = true
				end
			end
		end
	end

	if (casting == true) then
		-- I[o[hXs[hgp
		OverdSpeed_Interval = GetTick() + 65000 - OVERDSPEED_LV * 5000 -- ɂ܂ł̎
		SkillObject(MyID, OVERDSPEED_LV, IN_SKILL_OVEREDSPEED, MyID)
		Skill_Delay =  GetTick() + SKILL_INTERVAL					-- ɃXLgpł鎞
		MyDestX = 0
		MyDestY = 0
		TraceAI ("AUTO_SKILL_OVEREDSPEED")
	end
end

------------------------------------------
-- }X^[̋߂Ɉړ(_)
------------------------------------------
function MoveToMaster_Random (myid)
	
	local masterX, masterY =  GetV (V_POSITION,MyMASTER)
	
	local x, y
	x = math.floor(math.random(-2, 2))		-- XW_Ŏ擾
	y = math.floor(math.random(-2, 2))		-- YW_Ŏ擾
	
	if (x == 0 and y == 0) then			-- ̏ꍇ
		local moveflg = math.floor(math.random(0, 3))
		if (moveflg == 0) then
			x = 0
			y = 1
		elseif (moveflg == 1) then
			x = 0
			y = -1
		elseif (moveflg == 2) then
			x = 1
			y = 0
		elseif (moveflg == 3) then
			x = -1
			y = 0
		end
	end
	
	Move (MyID,masterX+x,masterY+y)

end

------------------------------------------
-- }X^[̋߂Ɉړ(Ŋ̈ʒu)
--    ̖_Fړ悪ړsZ̏ꍇAړłɌ̈ʒuŎ~܂܂B
------------------------------------------
function MoveToMaster (myid)

	local x1, y1 = GetV(V_POSITION,MyMASTER)
	local MyX, MyY = GetV (V_POSITION, myid)
	local x2,y2 = x1,y1

	if (x1 < MyX) then
		x2 = x2 + 1
	elseif (x1 > MyX) then
		x2 = x2 - 1
	end
	
	if (y1 < MyY) then
		y2 = y2 + 1
	elseif (x1 > MyX) then
		y2 = y2 - 1
	end
		
	Move(MyID,x2,y2)
	
end



------------------------------------------
-- XebvR}h
------------------------------------------
function StepCommand (myX, myY, ownerX, ownerY)

	-- ͎Ԃ𒴉߂ꍇAR}hZbg
	if (Command_Type ~= 0 and Command_Time < GetTick()) then
		Command_Type = 0
		Command_Count = 0
		TraceAI ("StepCommand : Command_TimeOut")
	end

	local cnt = Command_Count

	-----------------------------------------
	--- ANeBu[h
	-----------------------------------------
	--- A
	--- 偠
	--- @B
	--- ALT+ENbNŁA@AB̏Ƀzړ
	--- ANeBu܂B
	--- ANeBuɐہAz͎Ň@̈ʒuɈړB
	
	if (myX == ownerX - 1 and myY == ownerY - 1) then	-- @
		if (Command_Type == 0) then
			Command_Type = 1
			Command_Count = 1
			Command_Time = GetTick() + COMMAND_LIMIT
		end
	end
	if (myX == ownerX and myY == ownerY + 1) then		-- A
		if (Command_Type == 1 and Command_Count == 1) then
			Command_Count = 2
		end
	end
	if (myX == ownerX + 1 and myY == ownerY - 1) then	-- B
		if (Command_Type == 1 and Command_Count == 2) then
			Attack_Mode = 1									-- ANeBu
			Command_Conplete = true
			Command_Count = 0
			TraceAI ("StepCommand : Mode_Active")
		end
	end

	-----------------------------------------
	--- ANeBu[h
	-----------------------------------------
	--- @B
	--- 
	--- A
	--- ALT+ENbNŁA@AB̏Ƀzړ
	--- ANeBu܂B
	--- ANeBuɐہAz͎Ň@̈ʒuɈړB
	if (myX == ownerX - 1 and myY == ownerY + 1) then	-- @
		if (Command_Type == 0) then
			Command_Type = 2
			Command_Count = 4
			Command_Time = GetTick() + COMMAND_LIMIT
		end
	end
	if (myX == ownerX and myY == ownerY - 1) then		-- A
		if (Command_Type == 2 and Command_Count == 4) then
			Command_Count = 5
		end
	end
	if (myX == ownerX + 1 and myY == ownerY + 1) then	-- B
		if (Command_Type == 2 and Command_Count == 5) then
			Attack_Mode = 0									-- ANeBu
			Command_Conplete = true
			Command_Count = 0
			TraceAI ("StepCommand : Mode_NotActive")
		end
	end

	-----------------------------------------
	-- }X^[ꎞւ
	-----------------------------------------
	--- CB
	--- 偠
	--- @A
	--- ALT+ENbNŁA@AB̏Ƀzړ
	--- ɂvC[LorzNXꎞIɎlƂ܂B
	--- }X^[ꎞւɐہAz͎Ň@̈ʒuɈړB
	--- ΏPC{̎l苗ȏ㗣邩Aڈړ͂ŉ܂B
	
	if (Command_Type == 0 and Command_Count == 0) then						-- @
		Master_Change_X = myX
		Master_Change_Y = myY
		Command_Type = 3
		Command_Count = 7
		Command_Time = GetTick() + COMMAND_LIMIT
	end
	if (myX == Master_Change_X + 2 and myY == Master_Change_Y) then			-- A
		if (Command_Type == 3 and Command_Count == 7) then
			Command_Count = 8
		end
	end 
	if (myX == Master_Change_X + 2 and myY == Master_Change_Y + 2) then		-- B
		if (Command_Type == 3 and Command_Count == 8) then
			Command_Count = 9
		end
	end 
	if (myX == Master_Change_X and myY == Master_Change_Y + 2) then			-- C
		if (Command_Type == 3 and Command_Count == 9) then
			local actors = GetActors ()
			local chkX,chkY
			for i,v in ipairs(actors) do
				if ( v ~= myid) then
					chkX,chkY = GetV (V_POSITION,v)
					if (chkX == myX + 1 and chkY == myY - 1) then
						if IsPlayer(v) then					-- ΏۂvC[L̏ꍇ
							MyMASTER = v					-- ꎞ}X^[ɐݒ
							TraceAI ("MasterID : "..v)
							break;
						end
					end
				end
			end
			if (MyOWNER ~= MyMASTER) then
				Command_Conplete = true				-- }X^[ꎞւ
				Command_Count = 0
				TraceAI ("StepCommand : Master_Change")
			else
				Command_Type = 0					-- ւΏۖ
				Command_Count = 0
			end
		end
	end

	-- R}h͂ԈႦꍇAR}hZbg
	if (Command_Type ~= 0 and cnt == Command_Count) then
		Command_Type = 0
		Command_Count = 0
		TraceAI ("StepCommand : Command_Miss")
	end

end

------------------------------------------
-- ACh̎s
------------------------------------------
function Idle_Step (myid, masterid)
	
	local masterX, masterY = 0, 0
	
	if (First_Idle_Flag == 0) then						-- ACh
		First_Idle_Flag = 1
		masterX, masterY = GetV (V_POSITION,masterid)			-- l̍W擾
		Move (MyID,masterX - 1,masterY - 1)						-- 쐼Ɉړ
	end

	if (Idle_Time == 0) then							-- AChڍs͍sȂ
		Idle_Time = GetTick() + IDLE_DELAY * 1000
		Idle_Count = 0
		PatrolCount = 0
		PatrolFlag = math.floor(math.random(PATROL_MIN, PATROL_MAX))	-- ]񐔂_Ŏ擾
		if (math.floor(math.random(2)) == 1) then						-- ]_Ŏ擾
			PatrolDirection = 1
		else
			PatrolDirection = -1
		end
		-- ^C}[Az̎cHP/SP聓z
	elseif (Idle_Time < GetTick()) then
		if (PATROL_REST <= (GetV(V_HP,MyID)/GetV(V_MAXHP,MyID))*100 and PATROL_REST <= (GetV(V_SP,MyID)/GetV(V_MAXSP,MyID))*100) then
			if (Idle_Count < IDLE_FLAG) then				-- ʂɓ
				if (masterid == MyOWNER) then
					MoveToOwner (MyID)
				else
					MoveToMaster_Random (MyID)				-- ꎞ}X^[̋߂Ƀ_ړ
				end
				Idle_Count = Idle_Count + 1
				Idle_Time = GetTick() + IDLE_DELAY * 1000
			end
		end
	end
	if (Idle_Count == IDLE_FLAG) then							-- l̎]]]]
		masterX, masterY = GetV (V_POSITION,masterid)				-- l̍W擾
		if (WaitClock < GetTick()) then
			
			PatrolVector = PatrolVector + PatrolDirection	-- ]++
			if (PatrolVector == 0) then
				PatrolVector = 4
			elseif (PatrolVector == 5) then
				PatrolVector = 1
			end
			
			if (PatrolCount == 0) then						-- Jnʒu擾
				local x, y = GetV (V_POSITION,MyID)			-- ̍W擾
				if (x < masterX) then			-- 
					if (y < masterY) then		-- 쐼
						if (PatrolDirection == 1) then
							PatrolVector = 2				-- 
						else
							PatrolVector = 1				-- 
						end
					elseif (y > masterY) then	-- k
						if (PatrolDirection == 1) then
							PatrolVector = 3				-- k
						else
							PatrolVector = 2				-- 
						end
					else						-- ^
						if (PatrolDirection == 1) then
							PatrolVector = 3				-- k
						else
							PatrolVector = 1				-- 
						end
					end
				elseif (x > masterX) then		-- 
					if (y < masterY) then		-- 쓌
						if (PatrolDirection == 1) then
							PatrolVector = 1				-- 
						else
							PatrolVector = 4				-- 
						end
					elseif (y > masterY) then	-- k
						if (PatrolDirection == 1) then
							PatrolVector = 4				-- 
						else
							PatrolVector = 3				-- k
						end
					else						-- ^
						if (PatrolDirection == 1) then
							PatrolVector = 1				-- 
						else
							PatrolVector = 3				-- k
						end
					end
				else
					if (y < masterY) then		-- ^
						if (PatrolDirection == 1) then
							PatrolVector = 2				-- 
						else
							PatrolVector = 4				-- 
						end
					elseif (y > masterY) then	-- ^k
						if (PatrolDirection == 1) then
							PatrolVector = 4				-- 
						else
							PatrolVector = 2				-- 
						end
					else						-- 
						PatrolVector = 1					-- 
					end
				end
			end
			
			PatrolCount = PatrolCount + 1					-- ]++

			if (PatrolVector == 1) then
				Move (MyID,masterX             ,masterY-PATROL_RANGE)		--
			elseif (PatrolVector == 2) then
				Move (MyID,masterX-PATROL_RANGE,masterY             )		--
			elseif (PatrolVector == 3) then
				Move (MyID,masterX             ,masterY+PATROL_RANGE)		--k
			elseif (PatrolVector == 4) then
				Move (MyID,masterX+PATROL_RANGE,masterY             )		--
			end
			Idle_Time = GetTick() + IDLE_DELAY * 1000
			WaitClock = GetTick() + PATROL_SPEED

			if (PatrolCount > PatrolFlag) then
				Idle_Count = 0
				PatrolCount = 0
				PatrolFlag = math.floor(math.random(PATROL_MIN, PATROL_MAX))	-- ]񐔂_Ŏ擾
				if (math.floor(math.random(2)) == 1) then						-- ]_Ŏ擾
					PatrolDirection = 1
				else
					PatrolDirection = -1
				end
			end
		end
	end
	
end

------------- command process  ---------------------

function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")

	MyMASTER = MyOWNER		-- lZbg

	local curX, curY = GetV (V_POSITION,MyID)
	if ( x == curX and y == curY) then
		return		-- NbNꍇ́AȂ
	end
	
	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return		-- ړInƌݒn̏ꍇ́AȂ
	end

	if (math.abs(x-curX)+math.abs(y-curY) > 15) then		-- ړIn苗ȏȂ (T[o[ŉ͏Ȃ)
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})			-- ̖ړInւ̈ړ\񂷂
		x = math.floor((x+curX)/2)							-- Ԓn_ֈړ
		y = math.floor((y+curY)/2)							-- 
	end

	local ownerX, ownerY = GetOwnerPosition (MyID)			-- l̍W擾

	if (math.abs(x-ownerX) > 14 or math.abs(y-ownerY) > 14) then	-- l猩Ȃʒuɂ͈ړȂ
		return
	end

	Move (MyID,x,y)

	-- XebvR}h
	StepCommand (x, y, ownerX, ownerY)
	
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0

end




function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")

	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MySkill = 0

end




function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")

	MySkill = 0
	MyEnemy = id
	MyState = CHASE_ST

end




function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")

	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	
end



function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")

	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x
	MyDestY = y
	Move (MyID,x,y)
	MyState = PATROL_CMD_ST

end




function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")

	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MyState = HOLD_CMD_ST

end




function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")

	MySkillLevel = level
	MySkill = skill
	MyEnemy = id
	if (MySkill == IN_SKILL_MOONLIGHT and MySkillLevel == 1) then
		-- [CgLv1gpꍇȂΏۂɒʏUJn
		MySkill = 0
		MyState = CHASE_ST
	else
		if (MOONLIGHT_R_CANCELER == 0) then
			MyState = CHASE_ST
		else
			SkillObject(MyID,MySkillLevel,MySkill,MyEnemy)	-- ̏Ŕ
			MySkill = 0
			-- XLgp͏ԂωȂ
		end
	end

end




function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")

	Move (MyID,x,y)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end




function	OnFOLLOW_CMD ()

	-- ҋ@߂́Aҋ@ԂƋxԂ݂ɓ]
	if (MyState ~= FOLLOW_CMD_ST) then
		if (MyMASTER == MyOWNER or Follow_Target == 0) then
			MoveToOwner (MyID)
		else
			MoveToMaster_Random (MyID)				-- ꎞ}X^[̋߂Ƀ_ړ
		end
		MyState = FOLLOW_CMD_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyMASTER)
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("OnFOLLOW_CMD")
	else
		MyState = IDLE_ST
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")
	end

end




function	ProcessCommand (msg)

	if		(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end




-------------- state process  --------------------


function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	-- \R}h 
		return 
	end

	local object
	if (MyOWNER == MyMASTER) then					-- ꎞ}X^[w薳
		object = GetOwnerEnemy (MyID)
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			return 
		end
	elseif (Floow_Target == 0) then					-- lD
		object = GetOwnerEnemy (MyID)
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			return 
		end
		object = GetMasterEnemy (MyID)
		if (object ~= 0) then							-- MYMASTER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYMASTER_ATTACKED_IN")
			return 
		end
	else											-- ꎞ}X^[D
		object = GetMasterEnemy (MyID)
		if (object ~= 0) then							-- MYMASTER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYMASTER_ATTACKED_IN")
			return 
		end
		object = GetOwnerEnemy (MyID)
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			return 
		end
	end

	object = GetMyEnemy (MyID)
	if (object ~= 0) then							-- ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local distance
	if (MyOWNER == MyMASTER or Follow_Target == 0) then
		distance = GetDistanceFromOwner(MyID)
	else
		distance = GetDistance2(MyID, MyMASTER)
	end
	if ( distance > 3 or distance == -1) then		-- MYMASTER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return
	end

	local ownerX, ownerY
	local masterX, masterY
	if (MyOWNER ~= MyMASTER) then
		ownerX, ownerY = GetV (V_POSITION,MyOWNER)				-- l̍W擾
		masterX, masterY = GetV (V_POSITION,MyMASTER)			-- }X^[̍W擾
		if (math.abs(masterX - ownerX) > 12 or math.abs(masterY - ownerY) > 12) then	-- lƌ}X^[苗ȏ㗣ꂽ
			MyMASTER = MyOWNER															-- ]֌Wɖ߂
			MyState = FOLLOW_ST
			TraceAI ("Master_ReMove")
			TraceAI ("IDLE_ST -> FOLLOW_ST")
			return
		end
	end

	-- ACh̎s
	if (MyOWNER == MyMASTER or Follow_Target == 0) then
		Idle_Step(MyID, MyOWNER)
	else
		Idle_Step(MyID, MyMASTER)
	end

	-- XebvR}h
	if (Command_Conplete == true) then
		if (Command_Type == 1) then				-- ANeBu
			masterX, masterY = GetV (V_POSITION,MyOWNER)	-- l̍W擾
			Move (MyID,masterX - 1,masterY - 1)			-- l̓쐼Ɉړ
			Command_Type = 0
			Command_Conplete = false
		elseif (Command_Type == 2) then			-- ANeBu
			masterX, masterY = GetV (V_POSITION,MyOWNER)	-- l̍W擾
			Move (MyID,masterX - 1,masterY + 1)			-- l̖kɈړ
			Command_Type = 0
			Command_Conplete = false
		elseif (Command_Type == 3) then			-- }X^[ꎞϊ
			Move (MyID,Master_Change_X,Master_Change_Y)	-- R}hJnʒuɈړ
			Command_Type = 0
			Master_Change_X = 0
			Master_Change_Y = 0
			Command_Conplete = false
		end
	end

end



function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")

	local ownerX, ownerY
	local masterX, masterY
	if (MyOWNER ~= MyMASTER) then
		ownerX, ownerY = GetV (V_POSITION,MyOWNER)				-- l̍W擾
		masterX, masterY = GetV (V_POSITION,MyMASTER)			-- }X^[̍W擾
		if (math.abs(masterX - ownerX) > 12 or math.abs(masterY - ownerY) > 12) then	-- lƌ}X^[苗ȏ㗣ꂽ
			MyMASTER = MyOWNER															-- ]֌Wɖ߂
			TraceAI ("Master_ReMove")
			TraceAI ("FOLLOW_ST -> FOLLOW_ST")
			return
		end
	end

	local masterid
	if (MyMASTER == MyOWNER or Follow_Target == 0) then
		masterid = MyOWNER
	else
		masterid = MyMASTER
	end

	if (Follow_Time < GetTick()) then					-- ǔEFCg
		if (GetDistance2(MyID, masterid) <= 3) then		--  DESTINATION_ARRIVED_IN 
			MyState = IDLE_ST
			TraceAI ("FOLLOW_ST -> IDLW_ST")
			return
		elseif (GetV(V_MOTION,MyID) == MOTION_STAND or GetV(V_MOTION,MyID) == MOTION_MOVE) then
			if (GetV(V_MOTION, masterid) == MOTION_STAND or GetV(V_MOTION, masterid) == MOTION_SIT) then	-- l~܂Ă鎞
--			if (GetV(V_MOTION, masterid) == MOTION_STAND) then					-- l~܂Ă鎞
				if (masterid == MyOWNER) then									-- l̖TɊ
					MoveToOwner (MyID)
				else
					MoveToMaster (MyID)							-- ꎞ}X^[̋߂Ɉړ
				end
				TraceAI ("FOLLOW_ST -> IDLW_ST")
				Follow_Time = GetTick() + FOLLOW_INTERVAL		-- ɒǔ鎞
				return
			elseif (GetV(V_MOTION, masterid) == MOTION_MOVE) then				-- lĂ鎞
				local x,y = GetV(V_POSITION,masterid)							-- ľʒuֈړ
				Move (MyID,x,y)
				Follow_Time = GetTick() + FOLLOW_INTERVAL		-- ɒǔ鎞
				TraceAI ("FOLLOW_ST -> FOLLOW_ST")
				return
			end
		end
	end

end




function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")

	local ownerX, ownerY
	local masterX, masterY
	if (MyOWNER ~= MyMASTER) then
		ownerX, ownerY = GetV (V_POSITION,MyOWNER)				-- l̍W擾
		masterX, masterY = GetV (V_POSITION,MyMASTER)			-- }X^[̍W擾
		if (math.abs(masterX - ownerX) > 12 or math.abs(masterY - ownerY) > 12) then	-- lƌ}X^[苗ȏ㗣ꂽ
			MyMASTER = MyOWNER															-- ]֌Wɖ߂
			TraceAI ("Master_ReMove")
			TraceAI ("CHASE_ST -> CHASE_ST")
			return
		end
	end

	if IsOutOfSight(MyID,MyEnemy) then				-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if IsInAttackSight(MyID,MyEnemy) then			-- ENEMY_INATTACKSIGHT_IN
		MyState = ATTACK_ST
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)
	TraceAI ("OnCHASE_ST MyEnemy : ".. MyEnemy)
	if (MyDestX ~= x or MyDestY ~= y) then			-- DESTCHANGED_IN
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end

end


function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	local ownerX, ownerY
	local masterX, masterY
	if (MyOWNER ~= MyMASTER) then
		ownerX, ownerY = GetV (V_POSITION,MyOWNER)				-- l̍W擾
		masterX, masterY = GetV (V_POSITION,MyMASTER)			-- }X^[̍W擾
		if (math.abs(masterX - ownerX) > 12 or math.abs(masterY - ownerY) > 12) then	-- lƌ}X^[苗ȏ㗣ꂽ
			MyMASTER = MyOWNER															-- ]֌Wɖ߂
			TraceAI ("Master_ReMove")
			TraceAI ("ATTACK_ST -> ATTACK_ST")
			return
		end
	end

	if IsOutOfSight(MyID,MyEnemy) then					-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end

	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then		-- ENEMY_DEAD_IN
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end
		
	if not IsInAttackSight(MyID,MyEnemy) then			-- ENEMY_OUTATTACKSIGHT_IN
		MyState = CHASE_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	if (MySkill == 0) then
		-- XLgp([Cg)
		if (Auto_Skill_MoonLight() == true) then
			SkillObject (MyID, MySkillLevel, MySkill, MyEnemy)		-- XLgp
			Skill_Delay =  GetTick() + SKILL_INTERVAL					-- ɃXLgpł鎞
			TraceAI ("ATTACK_ST -> ATTACK_ST  : AUTO_SKILL MoonLight")
		else
			MySkill = 0
			MySkillLevel = 0
			Attack (MyID,MyEnemy)									-- ʏU
			TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
		end
		
	else
		SkillObject (MyID,MySkillLevel,MySkill,MyEnemy)
		-- fBCĐݒ
		if (MySkill == IN_SKILL_FLEETMOVE) then			-- tbg[u
			FleetMove_Interval = GetTick() + 65000 - MySkillLevel * 5000 + SKILL_INTERVAL		-- ɂ܂ł̎
			TraceAI ("ATTACK_ST -> ATTACK_ST : USE_SKILL_FLEETMOVE")
		elseif(MySkill == IN_SKILL_OVEREDSPEED) then	-- I[o[hXs[h
			OverdSpeed_Interval = GetTick() + 65000 - MySkillLevel * 5000 + SKILL_INTERVAL		-- ɂ܂ł̎
			TraceAI ("ATTACK_ST -> ATTACK_ST : USE_SKILL_ORBERDSPEED")
		end
		Skill_Delay =  GetTick() + SKILL_INTERVAL												-- ɃXLgpł鎞
		MySkill = 0
		MySkillLevel = 0
	end
	return


end


function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		MyState = IDLE_ST
	end
end




function OnSTOP_CMD_ST ()


end




function OnATTACK_OBJECT_CMD_ST ()

	

end




function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local object
	if (MyOWNER == MyMASTER) then				-- ꎞ}X^[w薳
		object = GetOwnerEnemy (MyID)
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	elseif (FloowTarget == 0) then				-- lD
		object = GetOwnerEnemy (MyID)
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	else										-- ꎞ}X^[D
		object = GetMasterEnemy (MyID)
		if (object == 0) then
			object = GetOwnerEnemy (MyID)
		end
	end
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
			MyState = IDLE_ST
	end

end




function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local object
	if (MyOWNER == MyMASTER) then
		object = GetOwnerEnemy (MyID)			-- ꎞ}X^[w薳
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	elseif (FloowTarget == 0) then				-- lD
		object = GetOwnerEnemy (MyID)
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	else										-- ꎞ}X^[D
		object = GetMasterEnemy (MyID)
		if (object == 0) then
			object = GetOwnerEnemy (MyID)
		end
	end
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)
	end

end




function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance(MyEnemy,MyID)
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end


	local object
	if (MyOWNER == MyMASTER) then				-- ꎞ}X^[w薳
		object = GetOwnerEnemy (MyID)
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	elseif (FloowTarget == 0) then				-- lD
		object = GetOwnerEnemy (MyID)
		if (object == 0) then
			object = GetMasterEnemy (MyID)
		end
	else										-- ꎞ}X^[D
		object = GetMasterEnemy (MyID)
		if (object == 0) then
			object = GetOwnerEnemy (MyID)
		end
	end
	if (object == 0) then
		object = GetMyEnemy (MyID)
		if (object == 0) then
			return
		end
	end

	MyEnemy = object

end




function OnSKILL_OBJECT_CMD_ST ()
	
end




function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then	-- DESTARRIVED_IN
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST
		MySkill = 0
	end

end




function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local masterX, masterY, myX, myY
	if (MyOWNER == MyMASTER or Floow_Target == 0) then
		masterX, masterY = GetV (V_POSITION,MyOWNER)	-- l̍W擾
	else
		masterX, masterY = GetV (V_POSITION,MyMASTER)	-- }X^[̍W擾
	end
	myX, myY = GetV (V_POSITION,MyID)					--  
	
	local d = GetDistance (masterX,masterY,myX,myY)

	if ( d <= 3) then										-- 3Zȉ̋Ȃ
		return 
	end

	local motion = GetV (V_MOTION,MyID)
	if (motion == MOTION_MOVE) then			-- ړ
		d = GetDistance (masterX, masterY, MyDestX, MyDestY)
		if ( d > 3) then										-- 4Zȏ̋Ȃ
			if (MyMASTER == MyOWNER or Floow_Target == 0) then	-- l̖TɊ
				MoveToOwner (MyID)
			else
				MoveToMaster (MyID)						-- ꎞ}X^[̋߂Ɉړ
			end
			MyDestX = masterX
			MyDestY = masterY
			return
		end
	else									-- ̓ 
		if (MyMASTER == MyOWNER or Floow_Target == 0) then		-- l̖TɊ
			MoveToOwner (MyID)
		else
			MoveToMaster (MyID)							-- ꎞ}X^[̋߂Ɉړ
		end
		MyDestX = masterX
		MyDestY = masterY
		return
	end
	
end






------------------------------------------
--  l̓G擾
------------------------------------------
function	GetOwnerEnemy (myid)
	local result = 0
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v == MyOWNER) then
			target = GetV (V_TARGET,v)
			if (IsMonster(target) == 1) then
				enemys[index] = target
				index = index+1
			end
		elseif (v ~= MyOWNER and v ~= MyMASTER and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == MyOWNER) then
				if (IsMonster(v) == 1) then
					if not IsPlant(GetV(V_HOMUNTYPE,v)) then			-- lɃq[WIȂ悤
						enemys[index] = v
						index = index+1
					end
				else
					local motion = GetV(V_MOTION,v)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end



------------------------------------------
--  }X^[̓G擾
------------------------------------------
function	GetMasterEnemy (myid)
	local result = 0
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v == MyMASTER) then
			target = GetV (V_TARGET,v)
			if (IsMonster(target) == 1) then
				enemys[index] = target
				index = index+1
			end
		elseif (v ~= MyOWNER and v ~= MyMASTER and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == MyMASTER) then
				if (IsMonster(v) == 1) then
					if not IsPlant(GetV(V_HOMUNTYPE,v)) then			-- }X^[Ƀq[WIȂ悤
						enemys[index] = v
						index = index+1
					end
				else
					local motion = GetV(V_MOTION,v)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end



------------------------------------------
--  G̎擾
------------------------------------------
function	GetMyEnemy (myid)
	local result = 0

	-- G[h̐ؑ
	if (Attack_Mode == 0) then
		result = GetMyEnemyA (myid)
	else
		result = GetMyEnemyB (myid)
	end
	return result
end


------------------------------------------
--  U^ GetMyEnemy
------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= MyOWNER and v ~= MyMASTER and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == myid) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end



------------------------------------------
--  U^ GetMyEnemy
------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local type
	for i,v in ipairs(actors) do
		if (v ~= MyOWNER and v ~= MyMASTER and v ~= myid) then
			if (1 == IsMonster(v) and GetDistance2(MyOWNER, v) <= 12)	then	-- l猩ȂG͖
				if ( GetV(V_MOTION,v) ~= MOTION_ATTACK or GetV(V_MOTION,v) ~= MOTION_ATTACK2 ) then --퓬łȂ
					if not IsPlant(GetV(V_HOMUNTYPE,v)) then					-- ARMOBłȂ
						if not IsNoMove(GetV(V_HOMUNTYPE,v)) then				-- ړ^MOBłȂ
							enemys[index] = v	-- G̃Xgɒǉ
							index = index+1
						end
					end
				elseif ( GetV(V_TARGET, v) == owner or GetV(V_TARGET,v) == MyID ) then --퓬ł肪lP~zgȂ
					enemys[index] = v			-- G̃Xgɒǉ
					index = index+1
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end


------------------------------------------
-- Q΍􏈗
------------------------------------------
function ExitEvent()
	do
		local x, y, timestamp = -1, -1, os.time()
		ExitEvent = function()
			local x2, y2 = GetV( V_POSITION, MyID )
			if x ~= x2 or y ~= y2 then
				x, y = x2, y2
				timestamp = os.time()
				return
			end
			if os.difftime( os.time(), timestamp ) >= EXIT_TIME then
				os.exit()
			end
		end
	end
end


function AI(myid)

	MyID = myid
	local msg	= GetMsg (myid)			-- command
	local rmsg	= GetResMsg (myid)		-- reserved command

	
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg) -- \R}hۑ
			end
		end
	else
		List.clear (ResCmdList)	-- VR}h͂ꂽA\R}h͍폜
		ProcessCommand (msg)	-- R}h 
	end

		
	-- ԏ 
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	end
	
	if (MyState ~= IDLE_ST) then	-- AChȊO
		Idle_Time = 0					--ҋ@s^C}[̃Zbg
		Idle_Count = 0
		PatrolCount = 0	
	end
	
	
	if (MyState == CHASE_ST or MyState == ATTACK_ST) then	-- 퓬
		if IsFILIR() then				-- tB[̏ꍇ
			Auto_Skill_OverdSpeed()		-- I[o[hXs[hgp
			Auto_Skill_FleetMove()		-- tbg[ugp
		end
	end

	ExitEvent()						-- Q΍􏈗
	

end


